const { EmbedBuilder, ActionRowBuilder, StringSelectMenuBuilder, StringSelectMenuOptionBuilder, PermissionFlagsBits, ComponentType } = require('discord.js');
const Command = require("../../src/structures/Command");

module.exports = class extends Command {
    constructor(client) {
        super(client, {
            name: "send",
            description: "Enviar a mensagem de ticket"
        });
    }

    run = async (interaction) => {
        if (!interaction.member.permissions.has(PermissionFlagsBits.Administrator)) return interaction.reply({
            content: `<a:fechar:1276883044900536391> • Você não tem permissão para executar este comando!`,
            ephemeral: true
        });

        const serverURL = await interaction.guild.iconURL();
        const embed = new EmbedBuilder()
        .setAuthor({
            name: `PT-SKILLS`,
            iconURL: `${serverURL}`
        })
        .setTitle(`<:ticket:1202703343294742581> • Suporte`)
        .setDescription(`👋 Olá.
    
<a:tada_confetti:1250224408908533760> Bem vindo(a) ao sistema de suporte da **PT-SKILLS**.
<:folha:1276882731145494652> Para abrir o seu ticket, selecione o departamento que gostaria de contactar.


<:aviso:1276882896648667222>  __Apenas marque, somente se pretenderes algo do que esta em cima, isto é uma ferramenta de trabalho!__
\`Após isso só aguardar alguém lhe responder ao pedido de suporte.\``)
        .setColor("Blue")
        .setThumbnail(serverURL)
        .setFooter({
            text: `${this.client.config.Copyright}`,
            iconURL: `${serverURL}`
        })
        .setTimestamp();

        let row = new ActionRowBuilder()
        .addComponents(
            new StringSelectMenuBuilder()
            .setCustomId('suporte.menu')
            .setDisabled(false)
            .setMaxValues(1)
            .setMinValues(0)
            .setPlaceholder("Escolha a categoria.")
            .setOptions(
                new StringSelectMenuOptionBuilder()
                .setLabel(`Suporte`)
                .setValue(`Suporte`)
                .setEmoji(`<:users:1276883311460880490>`)
                .setDescription(`Áreas relacionadas com suporte geral. (Não especificado nas categorias de suporte)`),

                new StringSelectMenuOptionBuilder()
                .setLabel(`Denúncia`)
                .setValue(`Denúncia`)
                .setEmoji(`<:4811reportraid:1250577036867534964>`)
                .setDescription(`Área destinada a denúncias de membros e/ou da equipa`),

                new StringSelectMenuOptionBuilder()
                .setLabel(`Compras`)
                .setValue(`Compras`)
                .setEmoji(`<:clientes:1276883881458667594>`)
                .setDescription(`Área destinada a compras.`),
            )
        )

        interaction.channel.send({
            embeds: [ embed ],
            components: [ row ]
        })
    };
}