const { Events } = require("discord.js");
const fs = require("fs");
const path = require("path");
const Event = require("../../structures/Event");

module.exports = class extends Event {
    constructor(client) {
        super(client, {
            name: Events.InteractionCreate
        });
    }

    run = async (interaction) => {
        const client = this.client;
        if (!interaction.isButton()) return;

        try {
            let embedOld = await interaction.message.embeds[0].description;
            if (embedOld) {
                const regex = /ID do Ticket: (\S+)/;

                let assumiu;

                const match = embedOld.match(regex);

                if (match) {
                    assumiu = match[1].replace(/\*/g, '');
                } else {
                    return assumiu = "Impossível"
                }

                if (assumiu !== "Impossível") {
                    if (interaction.customId == `ticket-${assumiu}`) {
                        const filePath = path.join("transcript", `transcript-${assumiu}.txt`);

                        await interaction.reply({
                            files: [
                                {
                                    attachment: filePath,
                                    name: 'trasncript.txt'
                                }
                            ],
                            ephemeral: true
                        });
                    }
                }
            } else {
                return false;
            }

        } catch (err) {
            console.log(err)
            return await interaction.reply({
                content: `<a:wumpus:1276886038564049020>・Ocorreu um erro ao executar a função!`,
                ephemeral: true
            });
        }
    }
}