const { Events, PermissionFlagsBits } = require("discord.js");
const Event = require("../../structures/Event");

module.exports = class extends Event {
    constructor(client) {
        super(client, {
            name: Events.InteractionCreate
        });
    }

    run = async (interaction) => {
        const client = this.client;
        if (!interaction.isUserSelectMenu()) return;

        if (interaction.customId == `ticket.add.user-${interaction.channel.id}`) {
            try {
                let user = await interaction.users.first();
                let userID = await client.tickets.get(`${interaction.channel.id}`);
                let user2 = await client.users.cache.get(userID.author);

                if (!user2) {
                    await interaction.reply({
                        content: `<a:fechar:1276883044900536391> • Não consegui adicionar esse usuário!`,
                        ephemeral: true
                    });
                }

                await interaction.guild.channels.edit(interaction.channel.id, {
                    permissionOverwrites: [
                        {
                            id: user.id,
                            allow: [ PermissionFlagsBits.ViewChannel, PermissionFlagsBits.SendMessages, PermissionFlagsBits.ReadMessageHistory ]
                        },
                        {
                            id: interaction.guild.roles.everyone,
                            deny: [PermissionFlagsBits.ViewChannel]
                        },
                        {
                            id: user2.id,
                            allow: [PermissionFlagsBits.ViewChannel, PermissionFlagsBits.SendMessages, PermissionFlagsBits.ReadMessageHistory]
                        },
                        {
                            id: client.config.Guild.Roles.Equipe,
                            allow: [PermissionFlagsBits.ViewChannel, PermissionFlagsBits.SendMessages, PermissionFlagsBits.ReadMessageHistory]
                        }
                    ]
                }).then(async () => {
                    await interaction.reply({
                        content: `<:right:1276886612797554709> • Você adicionou esse usuário com sucesso!`,
                        ephemeral: true
                    });
                }).catch(async err => {
                    await interaction.reply({
                        content: `<a:fechar:1276883044900536391> • Não consegui adicionar esse usuário!`,
                        ephemeral: true
                    });
                });
            } catch(err) {
                return await interaction.reply({
                    content: `<a:wumpus:1276886038564049020> • Ocorreu um erro ao executar a função!`,
                    ephemeral: true
                });
            }
        } else if (interaction.customId == `ticket.remove.user-${interaction.channel.id}`) {
            try {
                let user = await interaction.users.first();
                let userID = await client.tickets.get(`${interaction.channel.id}`);
                let user2 = await client.users.cache.get(userID.author);

                if (!user2) {
                    await interaction.reply({
                        content: `<a:fechar:1276883044900536391> • Não consegui adicionar esse usuário!`,
                        ephemeral: true
                    });
                }

                await interaction.guild.channels.edit(interaction.channel.id, {
                    permissionOverwrites: [
                        {
                            id: user.id,
                            deny: [ PermissionFlagsBits.ViewChannel ]
                        },
                        {
                            id: interaction.guild.roles.everyone,
                            deny: [PermissionFlagsBits.ViewChannel]
                        },
                        {
                            id: user2.id,
                            allow: [PermissionFlagsBits.ViewChannel, PermissionFlagsBits.SendMessages, PermissionFlagsBits.ReadMessageHistory]
                        },
                        {
                            id: client.config.Guild.Roles.Equipe,
                            allow: [PermissionFlagsBits.ViewChannel, PermissionFlagsBits.SendMessages, PermissionFlagsBits.ReadMessageHistory]
                        }
                    ]
                }).then(async () => {
                    await interaction.reply({
                        content: `<:right:1276886612797554709> • Você removeu esse usuário com sucesso!`,
                        ephemeral: true
                    });
                }).catch(async err => {
                    await interaction.reply({
                        content: `<a:fechar:1276883044900536391> • Não consegui remover esse usuário!`,
                        ephemeral: true
                    });
                });
            } catch(err) {
                return await interaction.reply({
                    content: `<a:wumpus:1276886038564049020> • Ocorreu um erro ao executar a função!`,
                    ephemeral: true
                });
            };
        };
    };
}